#define MODE_READ 0  // only read
#define MODE_WRITE 1 // test if already exists
#define MODE_OVWRT 2 // always overwrite old file, no test

FILE *open_file_interactive(char *defname, char *name_ret, int mode);
FILE *fopen_test(char *fina);

class window;
class text_scrollbar;
class text_window;

// text_window with an attached scrollbar
class text_viewer : public window {
  text_scrollbar *vs;
  text_window *tw;
public: 
  int slider_height(int zz);
  void reset(char *buf, int nc);
  text_viewer(window &parent, int w, int h, int x, int y, char *buf, 
	      int nc, int bw = 0);
  virtual void KeyPress_CB(XKeyEvent ev);
};

//  ************* vert_scrollbar ***********
//  vertical scrollbar with re-definable behaviour :
//  defines virtual functions for move (button 2) and jmp (button 1 &3)
//  should actually shift to window.h

class vert_scrollbar : public plate {
  plate *bar;
protected:
  int sw,sh,sx,sy,yspan; // span width for movement y = [0..yspan]
public:
  int yact; // actual position (0..yspan)
  void set_vars();
  // sh : height of slider
  vert_scrollbar(window &parent, int w, int h, int x, int y, int sh);
protected:
  virtual void move_callback(int y) { // called from draw (Button 2)
    set_slider(y - sy); 
  }
  virtual void jmp_callback(Bool up) { // called from pg (Button 1 & 3)
    set_slider( yact + (up) ? (-sh) : sh); // jmp +/- one sh
  } 
  // jump on mouse click
  virtual void BPress_CB(XButtonEvent ev);
  // draw if button 2 pressed
  virtual void Motion_CB(XMotionEvent ev);
public: 
  void set_slider(int y);
  // set slider in [0.0 .. 1.0] : 
  void set_slider_rel(float z) { set_slider(irint(z * yspan));}
  // called from resize && others 
  void slider_adapt(int shp); // adaptate to new slider height
  void resize(int w, int h);
  void adapt(int h, int shp);
};
