// image-view.c : standalone program for view of pictures from saved files
//   a part of PMS-grabber package
// the "GNU Public Lincense" policy applies to all programs of this package
// (c) Wolfgang Koehler, wolf@first.gmd.de, Dec. 1994
//     Kiefernring 15
//     14478 Potsdam, Germany
//     0331-863238

#include "window.h"
#include "view.h"
#include "ximage.h"
#include "evaluation.h"

// needed here because defined in view.h, but not used
void fast_capture(unsigned short*, int, int, int) {}

struct but_cb pal_list[] = 
   { {"set standard palette", std_coltab555 }, 
     {"grey scale palette", grey_coltab555 }, 
     {"set to last captured", set_auto_pal555 } };

struct but_cb file_list[] = 
   { { "save image.pix", save_pix },
     { "load image.pix", load_pix_interactive },
     { "save capture", save_capture },
     { "load capture", load_capture_interactive }, 
     { "save palette", save_palette },
     { "load palette", load_palette_interactive },
     { "save jpeg", save_jpeg },  { "load jpeg", load_jpeg },
     { "save ppm", save_ppm }
   };

main(int /*argc*/, char *argv[]) { 
  get_visual(); // init vars about visual
  biWidth = 340; biHeight = 255;
  int ww = biWidth+2, wh = biHeight + 40;

  display_main *mw = new display_main(argv[0],ww,wh);
  menu_bar *menub = mw->menub; grab_wi = mw->view;
  if (! True_Color) {
    make_pulldown_menu(*menub,"set palette",3, pal_list);
    new callback_button(*menub, "evaluate", make_eval_popup);
  }
  make_pulldown_menu(*menub,"file", sizeof(file_list)/sizeof(but_cb), 
		     file_list);
  new quit_button(*menub);

  max_cols = 0;
  long unsigned plane_mask; 
  if (! True_Color) {
    while // allocate all available color cells to array pixtab[] !!
      (XAllocColorCells(display,def_cmap,True,&plane_mask,0,
			&pixtab[max_cols],1)) 
	max_cols++; // number of color cells
    printf("allocated %d color cells\n",max_cols);
    std_coltab555();  
  }
  char *fina = "franzi.jpg";
  FILE *fload = fopen(fina,"r");  // start up with nice image
  if (fload) { 
    load_jpeg_file(fload); fclose(fload); 
    printf("loaded jpeg image from '%s'\n",fina); 
  }
  mw->main_loop();
  if (act_image) delete act_image; // free SHM descriptors !!
}

