// "snapshot.C" : standalon program to grab one frame from the PMS-card
//               and save into jpeg file, runs without X as command line
//  a part of PMS-grabber package
// the "GNU Public Lincense" policy applies to all programs of this package
// (c) Wolfgang Koehler, wolf@first.gmd.de, Dec. 1994
//     Kiefernring 15
//     14478 Potsdam, Germany
//     0331-863238

#include "grabber.h"

#include <fcntl.h>
#include <unistd.h>

#include "save.C"

void set_resolution(int w, int h) {
  if (verbose)
    fprintf(stderr,"setting resolution to %d x %d\n",w,h);
  SetMVVResolution(w,h);
}

// used from parse_args.C or parse_dummy.C
extern void parse_args(int, char**, int* , int* , int* );

void save_jpeg(int ww, int hh, int quality, FILE *fsave) { 
  if (fsave == NULL) { printf("cannot open output file\n"); exit(1); }
  int fid = open("/dev/fg", 0);
  if (fid > 0) {
    // simply waits until read is performed
    int ni; read(fid,&ni,4); 
    if (verbose) fprintf(stderr,"using interrupt driver\n");
  } else if (verbose) fprintf(stderr,"interrupt driver not installed\n");
  
  unsigned short cap_buf[ww*hh];
  fast_capture(cap_buf, ww, hh, 0); // always rgb 565
  compress_jpeg(fsave,quality,ww,hh,cap_buf);
  int fsize = ftell(fsave);
  if (verbose)
    fprintf(stderr,"saved jpeg q = %d (%d x %d) %d byte compfct = %.1f\n",
	    quality,ww,hh,fsize,2.0*ww*hh/fsize);
  fclose(fsave);
}

main(int argc, char *argv[]) {
  verbose = 0; options_verbose = 0; // switch off to keep stdout clean !!!
  
  int Width = 352, Height = 264; // default size
  int quality = 50; // default jpeg quality
  mvv_init();
  parse_args(argc, argv, &Width, &Height, &quality);
  set_resolution(Width, Height); // must be set before all_defaults
  all_defaults();                // otherwise the first image is incomplete !!
  save_jpeg(Width, Height, quality, stdout);

}


