extern Bool True_Color; // if T : no coltab mapping !
extern int image_depth; // 8 (PseudoColor) 16 (TrueColor) or 32

void get_visual(); // get these values

void save_image(XImage *ximage, char *fina, int ncols,unsigned long *pixtab);
XImage* load_image(char *fina, int &ncols, unsigned long *pixtab);

char *last_capfile();  // returns filename of last loaded capture
void load_pix_file(FILE *fload);
void load_capture_file(FILE *fload, char *);
void save_pix();
void load_pix_interactive();
void save_capture();
void save_ppm();
void load_capture_interactive();
void save_palette();
void load_palette_interactive();
void show_capture_dir(char *dirname);
void save_jpeg();
void load_jpeg();
void load_jpeg_file(FILE *fload);

void write_ppm_file_16(unsigned short *data,int width,int height,FILE *f);

void compress_jpeg(FILE *fsave, int quality, 
		   int ww, int hh, unsigned short* image_buf);
void JPEG_decompress(struct jpeg_decompress_struct *cinfo, 
		     unsigned short *image_buffer);

#ifdef MIT_SHM
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
extern "C" int XShmQueryExtension(Display*);
#endif

// class that holds an image buffer (short) and a Ximage struct
// if direct_map is True : grab directly into ximage buffer
// if shm is also True : try using SHM extension for speedup
class mapped_image {
  Bool direct_map, use_shm;
  int nn;
#ifdef MIT_SHM
  XShmSegmentInfo shminfo;
#endif
public: 
  unsigned short *buf_16; 
  XImage *ximage;

  mapped_image(int w, int h, Bool direct_map, Bool shm = True);
  ~mapped_image();
  void map_buffer(); // map cap_buf into ximage (or do nothing for direct_map )
  void PutImage(Drawable Win, int x, int y, int ww, int wh);

};


// a window to display mapped images (** only for 16bit colordepth now **)
class image_window : public window {
  mapped_image *mim;
public:
  XImage * sigcimg; // an image with significant pixels (background subtract)
  image_window(window &parent,int w, int h, int x, int y);
  ~image_window() { delete mim; }

  virtual void redraw();
  void PutPixel(int x, int y, unsigned short col);
  unsigned short GetPixel(int x, int y);
};

// image_window with an attached info window 
// which displays image infos on Pointer Motion
class image_info : public image_window {
  info_window *infw; 
  image_info(window &parent,int w, int h, int x, int y);
  void Motion_CB(XMotionEvent) {}
};
